#Embedded file name: /Users/versonator/Jenkins/live/output/mac_64_static/Release/midi-remote-scripts/Launchpad_Pro/SpecialDeviceComponent.py
from _Framework.DeviceComponent import DeviceComponent
from .consts import FADER_TYPE_STANDARD, DEVICE_MAP_CHANNEL

class SpecialDeviceComponent(DeviceComponent):

	def set_parameter_controls(self, controls):
		if controls:
			for control in controls:
				control.set_channel(DEVICE_MAP_CHANNEL)
				control.set_light_and_type('Device.On', FADER_TYPE_STANDARD)

		super(SpecialDeviceComponent, self).set_parameter_controls(controls)

	def _update_parameter_controls(self):
		if self._parameter_controls is not None:
			for control in self._parameter_controls:
				control.update()

	def update(self):
		super(SpecialDeviceComponent, self).update()
		if self.is_enabled():
			self._update_parameter_controls()